//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ModifyConponentFm.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TModifyConponentForm *ModifyConponentForm;
TFocusComponent *FocusComponent;
int i, j, nCreateCount;
bool gbCanMove=false, gbCanChangeSize=false;
TControl *FocusCtrl;
//---------------------------------------------------------------------------
__fastcall TModifyConponentForm::TModifyConponentForm(TComponent* Owner)
   : TForm(Owner)
{
   if(GetSystemDefaultLangID() == 1041)
   {
      ComStyleFileName = ExtractFilePath(Application->ExeName) + "ComStyle.cs";
      LangFileName     = ExtractFilePath(Application->ExeName) + "LanguageJ.ini";
      ChangCharset(JP);
      ChangeLanguage();
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::FormShow(TObject *Sender)/* TODO : lƩҦѼ */
{
   InitialModifyParameter();
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::InitialModifyParameter()/* TODO -cModifyConponentForm : lƩҦѼ */
{
   CBFormSelect->Clear();
   LBComponentSelect->Clear();

   //--- ͻPFormۦPƥتʺAListBox
   ComponentList = new TListBox *[Application->ComponentCount];
   for(i=0; i<Application->ComponentCount; i++)
   {
      ComponentList[i] = new TListBox(this);
      ComponentList[i]->Parent = ModifyConponentForm;
      ComponentList[i]->Visible = false;
   }
   //--- NFormW٤ΪsListBox
   for(i=0; i<Application->ComponentCount; i++)
   {
      if(Application->ComponentCount == NULL || Application->Components[i]->Name == "") continue;
      CBFormSelect->Items->InsertObject(0, Application->Components[i]->Name, (TObject *)Application->Components[i]);

      for(j=0; j<Application->Components[i]->ComponentCount; j++)
      {
         FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
         //ProperP_
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Visible");
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Font");
         if(FocusComponent == NULL || FocusComponent->Name == "" || !PropInfo) continue;
         ComponentList[i]->Items->InsertObject(0, FocusComponent->Name, (TObject *)FocusComponent);
      }
   }
   //--- Create nܪKө즲I
   nCreateCount = 0;
   CreateDragStop("TL", crSizeNWSE);   //DragPoint:TOP   ,Left
   CreateDragStop("CL", crSizeWE);     //DragPoint:Center,Left
   CreateDragStop("BL", crSizeNESW);   //DragPoint:Button,Left
   CreateDragStop("TC", crSizeNS);     //DragPoint:TOP   ,Center
   CreateDragStop("BC", crSizeNS);     //DragPoint:Button,Center
   CreateDragStop("TR", crSizeNESW);   //DragPoint:TOP   ,Right
   CreateDragStop("CR", crSizeWE);     //DragPoint:Center,Right
   CreateDragStop("BR", crSizeNWSE);   //DragPoint:Button,Right
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   for(i=0; i<8; i++)
   {
      if(DisPanel[i] != NULL)
      {
         delete DisPanel[i];
         DisPanel[i] = NULL;
      }
   }

   for(i=0; i<Application->ComponentCount; i++)
      delete ComponentList[i];
   delete [] ComponentList;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::CBFormSelectChange(TObject *Sender)/* TODO -cModifyConponentForm : Form */
{
   LBComponentSelect->Clear();
   for(i=0; i<Application->ComponentCount ;i++)
   {
      if(Application->ComponentCount == NULL || Application->Components[i]->Name == "") continue;
      if(CBFormSelect->Text == Application->Components[i]->Name)
      {
         dynamic_cast<TForm *>(Application->Components[i])->Visible = true;
         LBComponentSelect->Items = ComponentList[i]->Items;
         DisplayForm = Application->Components[i];
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::LBComponentSelectMouseUp(TObject *Sender,/* TODO -cModifyConponentForm : Component */
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   AnsiString TabSheetName;
   TControl *TmpCtrl;
   int Index = LBComponentSelect->ItemAtPos(Point(X,Y), true);
   ClassRef=LBComponentSelect->Items->Objects[Index]->ClassType();
   for (ClassRef; ClassRef!=NULL; ClassRef=ClassRef->ClassParent())
   {
      if (String(ClassRef->ClassName()) == "TControl")
      {
         FocusComponent = (TFocusComponent *)LBComponentSelect->Items->Objects[Index];
         StatusBar1->SimpleText = FocusComponent->Name + " is at (" + IntToStr(FocusComponent->Left) + ", " + IntToStr(FocusComponent->Top) + ")";

         ReDrawDragStop();

         // npxs^禡O?
//         tmpMethod[1] = FocusComponent->OnMouseDown;
//         tmpMethod[2] = FocusComponent->OnMouseUp;
//         tmpMethod[3] = FocusComponent->OnClick;

         FocusComponent->OnMouseMove = PosMouseMove;
         FocusComponent->OnMouseDown = PosMouseDown;
         FocusComponent->OnMouseUp   = PosMouseUp;
         FocusComponent->OnClick     = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::btnModifyFormCloseClick(TObject *Sender)
{
   AnsiString FormCloseName;
   for(i=0; i<Application->ComponentCount ;i++)
   {
      FormCloseName = Application->Components[i]->Name;
      if(Application->ComponentCount == NULL || FormCloseName == "" ||
         FormCloseName == "MainForm" || FormCloseName == "ModifyConponentForm") continue;
      if(CBFormSelect->Text == FormCloseName)
         dynamic_cast<TForm *>(Application->Components[i])->Visible = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::AdjustComponentPosition(TObject * Sender)/* TODO -cModifyConponentForm : ʤm */
{
   if(FocusComponent == NULL) {  ShowMessage("Please select object !!!");  return;  }
   int s = ((TComponent *)Sender)->Tag;
   switch(s)
   {
      case 0:
            if(RBPosMove->Checked)  FocusComponent->Top    -= StrToInt(edComponentShift->Text);
            else                    FocusComponent->Height -= StrToInt(edComponentShift->Text);
            break;
      case 1:
            if(RBPosMove->Checked)  FocusComponent->Top    += StrToInt(edComponentShift->Text);
            else                    FocusComponent->Height += StrToInt(edComponentShift->Text);
            break;
      case 2:
            if(RBPosMove->Checked)  FocusComponent->Left  -= StrToInt(edComponentShift->Text);
            else                    FocusComponent->Width -= StrToInt(edComponentShift->Text);
            break;
      case 3:
            if(RBPosMove->Checked)  FocusComponent->Left  += StrToInt(edComponentShift->Text);
            else                    FocusComponent->Width += StrToInt(edComponentShift->Text);
            break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::ComponentStyleChange(TObject * Sender)/* TODO -cModifyConponentForm : 󴫦r˦ */
{
   if(FocusComponent == NULL) {  ShowMessage("Please select object !!!");  return;  }
   int s = ((TComponent *)Sender)->Tag;
   switch(s)
   {
      case 0:  FocusComponent->Font->Style = TFontStyles() << fsBold;   break;
      case 1:  FocusComponent->Font->Style = TFontStyles() << fsItalic; break;
      case 2:  FocusComponent->Font->Style = TFontStyles() << fsUnderline; break;
      case 3:  FocusComponent->Font->Style = TFontStyles() << fsStrikeOut; break;
      default: FocusComponent->Font->Style = TFontStyles() >> fsBold >> fsItalic >> fsUnderline >> fsStrikeOut;   break;
   }
   ReDrawDragStop();
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::CBSizeChange(TObject *Sender)/* TODO -cModifyConponentForm : 󴫦rؤo */
{
   if(FocusComponent == NULL)
   {  ShowMessage("Please select object !!!");  return;  }
   FocusComponent->Font->Size = StrToInt(CBSize->Text);
   ReDrawDragStop();
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::btnSaveClick(TObject *Sender)
{
   Screen->Cursor=crHourGlass;
   TIniFile *StyleFile = new TIniFile(ComStyleFileName);
   for(i=0; i<Application->ComponentCount; i++)
   {
      if(Application->Components[i] == NULL || Application->Components[i]->Name == "" || Application->Components[i] == this) continue;
      for(j=0; j<Application->Components[i]->ComponentCount; j++)
      {
         FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
         //ProperP_
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Visible");
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Font");
         if(FocusComponent == NULL || FocusComponent->Name == "" || !PropInfo) continue;
         // Font Style
         if(FocusComponent->Font->Style == TFontStyles() << fsBold)           FontStyle=1;
         else if(FocusComponent->Font->Style == TFontStyles() << fsItalic)    FontStyle=2;
         else if(FocusComponent->Font->Style == TFontStyles() << fsUnderline) FontStyle=3;
         else if(FocusComponent->Font->Style == TFontStyles() << fsStrikeOut) FontStyle=4;
         else                                                                 FontStyle=0;

         sComponentStyle = "FontStyle,"  +String(FontStyle)+
                           ",FontSize,"  +String(FocusComponent->Font->Size)+
                           ",Left,"      +String(FocusComponent->Left)+
                           ",Top,"       +String(FocusComponent->Top)+
                           ",Width,"     +String(FocusComponent->Width)+
                           ",Height,"    +String(FocusComponent->Height);

         StyleFile->WriteString(Application->Components[i]->Name, FocusComponent->Name, sComponentStyle);
      }
   }
   delete StyleFile;
   Screen->Cursor=crArrow;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::btnLoadClick(TObject *Sender)
{
   Screen->Cursor=crHourGlass;
   TIniFile *StyleFile = new TIniFile(ComStyleFileName);
   for(i=0; i<Application->ComponentCount; i++)
   {
      if(Application->Components[i] == NULL || Application->Components[i]->Name == "" || Application->Components[i] == this) continue;
      for(j=0; j<Application->Components[i]->ComponentCount; j++)
      {
         FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
         //ProperP_
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Visible");
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Font");
         if(FocusComponent == NULL || FocusComponent->Name == "" || !PropInfo) continue;
         sComponentStyle = StyleFile->ReadString(Application->Components[i]->Name, FocusComponent->Name, "NULL");

         GetValue(sComponentStyle, FontStyle, FontSize, FLeft, FTop, FWidth, FHeight);

         if(FontStyle==1)      FocusComponent->Font->Style == TFontStyles() << fsBold;
         else if(FontStyle==2) FocusComponent->Font->Style == TFontStyles() << fsItalic;
         else if(FontStyle==3) FocusComponent->Font->Style == TFontStyles() << fsUnderline;
         else if(FontStyle==4) FocusComponent->Font->Style == TFontStyles() << fsStrikeOut;
         else                  FocusComponent->Font->Style == TFontStyles();

         FocusComponent->Font->Size = FontSize;
         FocusComponent->Left       = FLeft;
         FocusComponent->Top        = FTop;
         FocusComponent->Width      = FWidth;
         FocusComponent->Height     = FHeight;
      }
   }
   delete StyleFile;
   Screen->Cursor=crArrow;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::GetValue(AnsiString sTmp, int &FontStyle, int &FontSize, int &FLeft, int &FTop, int &FWidth, int &FHeight)
{
   int StringPos;

   StringPos = sTmp.Pos(",");
   sTmp = sComponentStyle.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //FontStyle
   FontStyle = StrToInt(sTmp.SubString(1,StringPos-1));
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //FontSize
   FontSize = StrToInt(sTmp.SubString(1,StringPos-1));
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //Left
   FLeft = StrToInt(sTmp.SubString(1,StringPos-1));
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //Top
   FTop = StrToInt(sTmp.SubString(1,StringPos-1));
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //Width
   FWidth = StrToInt(sTmp.SubString(1,StringPos-1));
   sTmp = sTmp.SubString(StringPos+1,sTmp.Length());   StringPos = sTmp.Pos(",");
   //Height
   FHeight = StrToInt(sTmp.SubString(StringPos+1,sTmp.Length()));
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::btnSaveMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(Button==mbRight)
   {
      Screen->Cursor=crHourGlass;
      if(FileExists(LangFileName)) DeleteFile(LangFileName);
      TIniFile *InFile = new TIniFile(LangFileName);
      for(i=0; i<Application->ComponentCount; i++)
      {
         if(Application->ComponentCount == NULL || Application->Components[i]->Name == "" || Application->Components[i] == this)
            continue;

         for(j=0; j<Application->Components[i]->ComponentCount; j++)
         {
            FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
            //ProperP_
            PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Visible");

            //wS
            if(String(FocusComponent->ClassName()) == "TListView")
            {
               for(int k=0; k<dynamic_cast<TListView *>((TControl *)FocusComponent)->Columns->Count; k++)
                  InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".Columns"+String(k),dynamic_cast<TListView *>((TControl *)FocusComponent)->Columns->Items[k]->Caption);
               continue;
            }
            if(String(FocusComponent->ClassName()) == "TComboBox")
            {
               for(int k=0; k<dynamic_cast<TComboBox *>((TControl *)FocusComponent)->Items->Count; k++)
                  InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".Items"+String(k),dynamic_cast<TComboBox *>((TControl *)FocusComponent)->Items->Strings[k]);
               continue;
            }
            if(String(FocusComponent->ClassName()) == "TDBChart")
            {
               InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".Title",dynamic_cast<TDBChart *>((TControl *)FocusComponent)->Title->Text->Text);
               for(int k=0; k<dynamic_cast<TDBChart *>((TControl *)FocusComponent)->SeriesList->Count; k++)
                  InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".SeriesList"+String(k),dynamic_cast<TDBChart *>((TControl *)FocusComponent)->SeriesList->Series[k]->Title);
               continue;
            }
            if(String(FocusComponent->ClassName()) == "TPageControl")
            {
               for(int k=0; k<dynamic_cast<TPageControl *>((TControl *)FocusComponent)->PageCount; k++)
                  InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".Page"+String(k),dynamic_cast<TPageControl *>((TControl *)FocusComponent)->Pages[k]->Caption);
               continue;
            }

            PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Caption");
            if(FocusComponent == NULL || FocusComponent->Name == "" || !PropInfo || !FocusComponent->Visible || FocusComponent->Caption == "")
            continue;
            InFile->WriteString(Application->Components[i]->Name,FocusComponent->Name+".Caption",FocusComponent->Caption);
         }
      }
      delete InFile;
      Screen->Cursor=crArrow;
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::ChangeLanguage()/* TODO -cModifyConponentForm : y */
{
   Screen->Cursor=crHourGlass;
   TIniFile *InFile = new TIniFile(LangFileName);
   for(int i=0; i<Application->ComponentCount; i++)
   {
      if(Application->ComponentCount == NULL || Application->Components[i]->Name == "" || Application->Components[i] == this)
         continue;

      for(int j=0; j<Application->Components[i]->ComponentCount; j++)
      {
         FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
         //ProperP_
         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Visible");

         //wS
         if(String(FocusComponent->ClassName()) == "TListView")
         {
            for(int k=0; k<dynamic_cast<TListView *>((TControl *)FocusComponent)->Columns->Count; k++)
               dynamic_cast<TListView *>((TControl *)FocusComponent)->Columns->Items[k]->Caption = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".Columns"+String(k),"NULL");
            continue;
         }
         if(String(FocusComponent->ClassName()) == "TComboBox")
         {
            for(int k=0; k<dynamic_cast<TComboBox *>((TControl *)FocusComponent)->Items->Count; k++)
               dynamic_cast<TComboBox *>((TControl *)FocusComponent)->Items->Strings[k] = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".Items"+String(k),"NULL");
            continue;
         }
         if(String(FocusComponent->ClassName()) == "TDBChart")
         {
            dynamic_cast<TDBChart *>((TControl *)FocusComponent)->Title->Text->Text = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".Title","NULL");
            for(int k=0; k<dynamic_cast<TDBChart *>((TControl *)FocusComponent)->SeriesList->Count; k++)
               dynamic_cast<TDBChart *>((TControl *)FocusComponent)->SeriesList->Series[k]->Title = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".SeriesList"+String(k),"NULL");
            continue;
         }
         if(String(FocusComponent->ClassName()) == "TPageControl")
         {
            for(int k=0; k<dynamic_cast<TPageControl *>((TControl *)FocusComponent)->PageCount; k++)
               dynamic_cast<TPageControl *>((TControl *)FocusComponent)->Pages[k]->Caption = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".Page"+String(k),"NULL");
            continue;
         }

         PropInfo=GetPropInfo((TTypeInfo *)FocusComponent->ClassInfo(),"Caption");
         if(FocusComponent == NULL || FocusComponent->Name == "" || !PropInfo || !FocusComponent->Visible || FocusComponent->Caption == "")
            continue;
         FocusComponent->Caption = InFile->ReadString(Application->Components[i]->Name,FocusComponent->Name+".Caption","NULL");
      }
   }
   delete InFile;
   Screen->Cursor=crArrow;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::ChangCharset(int LangSwitch)
{
   for(int i=1; i<Application->ComponentCount; i++)
   {
      for(int j=0; j<Application->Components[i]->ComponentCount; j++)
      {
         if(dynamic_cast<TControl *>(Application->Components[i]->Components[j]) != NULL)
         {
            FocusComponent = (TFocusComponent *)Application->Components[i]->Components[j];
            if(LangSwitch == JP)
            {
               FocusComponent->Font->Charset = SHIFTJIS_CHARSET;
               FocusComponent->Font->Name = "MS Gothic";
               if(String(FocusComponent->ClassName()) == "TDBChart")
               {
                  dynamic_cast<TDBChart *>((TControl *)FocusComponent)->Legend->Font->Charset = SHIFTJIS_CHARSET;
                  dynamic_cast<TDBChart *>((TControl *)FocusComponent)->Legend->Font->Name = "MS Gothic";
               }
            }
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::CreateDragStop(AnsiString Loc, TCursor Cur)/* TODO : إ8өI */
{
   DisPanel[nCreateCount] = new TPanel(this);
   DisPanel[nCreateCount]->Parent = this;
   DisPanel[nCreateCount]->Height = 4;
   DisPanel[nCreateCount]->Width = 4;
   DisPanel[nCreateCount]->Color = clBlack;
   DisPanel[nCreateCount]->BevelOuter = bvNone;
   DisPanel[nCreateCount]->Cursor = Cur;
   DisPanel[nCreateCount]->Name = Loc;
   DisPanel[nCreateCount]->OnMouseMove = SizeMouseMove;
   DisPanel[nCreateCount]->OnMouseDown = SizeMouseDown;
   DisPanel[nCreateCount]->OnMouseUp   = SizeMouseUp;
   nCreateCount++;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::ReDrawDragStop()
{
   int CmpTop, CmpLeft, CmpWidth, CmpHeight;
   CmpTop = FocusComponent->Top;
   CmpLeft  = FocusComponent->Left;
   CmpWidth = FocusComponent->Width;
   CmpHeight = FocusComponent->Height;
   SetDragStopPos(CmpLeft-2,          CmpTop-2,           "TL");
   SetDragStopPos(CmpLeft-2,          CmpTop+CmpHeight/2, "CL");
   SetDragStopPos(CmpLeft-2,          CmpTop+CmpHeight-2, "BL");
   SetDragStopPos(CmpLeft+CmpWidth/2, CmpTop-2,           "TC");
   SetDragStopPos(CmpLeft+CmpWidth/2, CmpTop+CmpHeight-2, "BC");
   SetDragStopPos(CmpLeft+CmpWidth-2, CmpTop-2,           "TR");
   SetDragStopPos(CmpLeft+CmpWidth-2, CmpTop+CmpHeight/2, "CR");
   SetDragStopPos(CmpLeft+CmpWidth-2, CmpTop+CmpHeight-2, "BR");
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::SetDragStopPos(int Left, int Top, AnsiString Loc)/* TODO : ]w8өIm */
{
   for(i=0; i<8; i++)
   {
      if(DisPanel[i]->Name == Loc)
      {
         DisPanel[i]->Left = Left;
         DisPanel[i]->Top = Top;
         DisPanel[i]->Parent = (TWinControl *)FocusComponent->Parent;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::PosMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
   if(!ssLeft || !gbCanMove)   return;
   FocusComponent->Left = FocusComponent->Left + X - dx;
   FocusComponent->Top  = FocusComponent->Top  + Y - dy;
   ReDrawDragStop();
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::PosMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
   dx = X;
   dy = Y;
   gbCanMove = true;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::PosMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
   gbCanMove = false;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::SizeMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
   FocusCtrl = GetCaptureControl(); // o즲I
   if(FocusCtrl == NULL)   return;
   if(!ssLeft || !gbCanChangeSize)   return;
   if(FocusCtrl->Name[1] == 'T')
   {
      FocusComponent->Height = max(0, FocusComponent->Top + FocusComponent->Height - (Y + FocusCtrl->Top));
      FocusComponent->Top    = Y + FocusCtrl->Top;
   }
   if(FocusCtrl->Name[1] == 'B')
   {
      FocusComponent->Height = max(0, Y + FocusCtrl->Top - FocusComponent->Top);
   }
   if(FocusCtrl->Name[2] == 'L')
   {
      FocusComponent->Width = max(0, FocusComponent->Width + FocusComponent->Left - (X + FocusCtrl->Left));
      FocusComponent->Left  = X + FocusCtrl->Left;
   }
   if(FocusCtrl->Name[2] == 'R')
   {
      FocusComponent->Width = max(0, X + FocusCtrl->Left - FocusComponent->Left);
   }
   ReDrawDragStop();
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::SizeMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
   SetCaptureControl(dynamic_cast<TControl *>(Sender));
   gbCanChangeSize = true;
}
//---------------------------------------------------------------------------
void __fastcall TModifyConponentForm::SizeMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
   gbCanChangeSize = false;
}
//---------------------------------------------------------------------------

